<?php
/* last edit by Compuart Nov 13 2002 */
/*****************************************************************************/
/* index.php                                                                 */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

/* ### Version Info ### */
$YaBBversion = 'YaBB SE 1.5.3';
$YaBBphpver = 'YaBB SE 1.5.3';
define('YaBBSE', 1);

$time_start = getmicrotime();

$types_to_register = array('GET', 'POST', 'COOKIE', 'SESSION', 'SERVER');
foreach ($types_to_register as $type) {
	$arr = @${'HTTP_' . $type . '_VARS'};
	if (@count($arr) > 0)
		extract($arr, EXTR_OVERWRITE);
}

error_reporting (E_ALL ^ E_NOTICE);

include_once("QueryString.php");
include_once("Settings.php");
include_once("$sourcedir/Subs.php");
include_once("$sourcedir/Errors.php");
include_once("$sourcedir/Load.php");
include_once("$sourcedir/Security.php");
$dbcon = mysql_connect($db_server, $db_user, $db_passwd) or die(mysql_error());
mysql_select_db($db_name) or die(mysql_error());

$doLimitOne = '';

/* ### Log this click ### */
ClickLog();

/* ### Load the user's cookie (or set to guest) ### */
LoadCookie();

/* ### Load user settings ### */
LoadUserSettings();

/* ### load modsettings ### */
$modSettings = array();
$request = mysql_query("SELECT variable,value FROM {$db_prefix}settings WHERE (variable != 'agreement')") or database_error(__FILE__, __LINE__);
while ($row = mysql_fetch_array($request))
	$modSettings[$row['variable']] = $row['value'];
$chklngfile = $chklngfile2 = $settings[23];

if ($modSettings['enableCompressedOutput'] && preg_match('/gzip/i', getEnv('HTTP_ACCEPT_ENCODING')) && @ini_get('zlib.output_compression') != '1')
	ob_start("ob_gzhandler");
else
	ob_start();

if (function_exists('session_start'))
{
	session_start();
	$sc = session_id();
}
else
	$sc = '';
	
/* ### load language file ### */
if ($modSettings['userLanguage'] == 1)
{
	if ($chklngfile == Null)
		include_once($language);
	else
		include_once($chklngfile2);
}
else
	include_once($language);

/* ### Security stuff ### */
if (($board != '' && !is_numeric($board)) || ($threadid != '' && !is_numeric($threadid)))
	fatal_error($txt[399]);

/* ### Banning ### */
banning();

/* ### Write log ### */
WriteLog();

/* ### Load board information ### */
LoadBoard();

set_error_handler("yabb_error_handler");
yymain();

function  yymain()
{
	global $maintenance, $action, $sourcedir, $settings, $username, $guestaccess, $modSettings, $currentboard, $db_prefix, $timeoffset;

	/* #### Choose what to do based on the form action #### */
	if ($maintenance == 1 && $action == 'login2')
	{
		include_once("$sourcedir/LogInOut.php");
		Login2();
	}
	if ($maintenance == 1 && $settings[7] != 'Administrator')
	{
		include_once ("$sourcedir/Maintenance.php");
		InMaintenance();
	}
	/* ### Guest can do the very few following actions. */
	if ($username == 'Guest' && $guestaccess == 0)
		if (!(($action == 'login') || ($action == 'login2') || ($action == 'register') || ($action == 'register2') || ($action == 'reminder')))
			KickGuest();

	if (($modSettings['trackStats'] == '1') && ($modSettings['hitStats'] == '1'))
	{
		$date = getdate(time() + $timeoffset * 3600);
		$statsquery = mysql_query("UPDATE {$db_prefix}log_activity SET hits = hits + 1 WHERE month = $date[mon] AND day = $date[mday] AND year = $date[year]") or database_error(__FILE__, __LINE__);
		if (mysql_affected_rows() == 0)
			$statsquery = mysql_query("INSERT INTO {$db_prefix}log_activity (month, day, year, hits) VALUES ($date[mon], $date[mday], $date[year], 1)") or database_error(__FILE__, __LINE__);
	}


	$actionArray = array(
		'addboard' => array("$sourcedir/ManageBoards.php", 'CreateBoard'),
		'admin' => array("$sourcedir/Admin.php", 'Admin'),
		'boardrecount' => array("$sourcedir/Admin.php", 'AdminBoardRecount'),
		'calendar' => array("$sourcedir/Calendar.php", 'ShowCalendar'),
		'calendaree' => array("$sourcedir/Calendar.php", 'CalendarEditEvent'),
		'calendaree2' => array("$sourcedir/Calendar.php", 'CalendarEditEvent2'),
		'calendarle' => array("$sourcedir/Calendar.php", 'CalendarLinkEvent'),
		'calendarle2' => array("$sourcedir/Calendar.php", 'CalendarLinkEvent2'),
		'calendarpe' => array("$sourcedir/Calendar.php", 'CalendarPostEvent'),
		'clean_log' => array("$sourcedir/Admin.php", 'clean_log'),
		'createcat' => array("$sourcedir/ManageCats.php", 'CreateCat'),
		'deleteErrors' => array("$sourcedir/Errors.php", 'DeleteErrors'),
		'deletemultimembers' => array("$sourcedir/Admin.php", 'DeleteMultiMembers'),
		'detailedversion' => array("$sourcedir/Admin.php", 'ver_detail'),
		'display' => array("$sourcedir/Display.php", 'Display'),
		'displaynew' => array("$sourcedir/DisplayNew.php", 'DisplayNew'),
		'do_clean_log' => array("$sourcedir/Admin.php", 'do_clean_log'),
		'dumpdb' => array("$sourcedir/Admin.php", 'DumpDatabase'),
		'editagreement' => array("$sourcedir/Admin.php", 'EditAgreement'),
		'editagreement2' => array("$sourcedir/Admin.php", 'EditAgreement2'),
		'editnews' => array("$sourcedir/Admin.php", 'EditNews'),
		'editnews2' => array("$sourcedir/Admin.php", 'EditNews2'),
		'editpoll' => array("$sourcedir/Poll.php", 'EditPoll'),
		'editpoll2' => array("$sourcedir/Poll.php", 'EditPoll2'),
		'helpadmin' => array("help.php", ''),
		'icqpager' => array("$sourcedir/ICQPager.php", 'IcqPager'),
		'im' => array("$sourcedir/InstantMessage.php", 'IMIndex'),
		'imoutbox' => array("$sourcedir/InstantMessage.php", 'IMOutbox'),
		'imprefs' => array("$sourcedir/InstantMessage.php", 'IMPreferences'),
		'imprefs2' => array("$sourcedir/InstantMessage.php", 'IMPreferences2'),
		'imremove' => array("$sourcedir/InstantMessage.php", 'IMRemove'),
		'imremoveall' => array("$sourcedir/InstantMessage.php", 'KillAllQuery'),
		'imremoveall2' => array("$sourcedir/InstantMessage.php", 'KillAll'),
		'imremovemore' => array("$sourcedir/InstantMessage.php", 'IMRemoveMore'),
		'imsend' => array("$sourcedir/InstantMessage.php", 'IMPost'),
		'imsend2' => array("$sourcedir/InstantMessage.php", 'IMPost2'),
		'ipban' => array("$sourcedir/Admin.php", 'ipban'),
		'ipban2' => array("$sourcedir/Admin.php", 'ipban2'),
		'lock' => array("$sourcedir/LockThread.php", 'LockThread'),
		'lockVoting' => array("$sourcedir/Poll.php", 'LockVoting'),
		'login' => array("$sourcedir/LogInOut.php", 'Login'),
		'login2' => array("$sourcedir/LogInOut.php", 'Login2'),
		'logout' => array("$sourcedir/LogInOut.php", 'Logout'),
		'mailing' => array("$sourcedir/Admin.php", 'MailingList'),
		'manageattachments' => array("$sourcedir/ManageAttachments.php", 'ManageAttachments'),
		'manageboards' => array("$sourcedir/ManageBoards.php", 'ManageBoards'),
		'managecats' => array("$sourcedir/ManageCats.php", 'ManageCats'),
		'markallasread' => array("$sourcedir/BoardIndex.php", 'MarkAllRead'),
		'markasread' => array("$sourcedir/MessageIndex.php", 'MarkRead'),
		'membershiprecount' => array("$sourcedir/Admin.php", 'AdminMembershipRecount'),
		'mergethreads' => array("$sourcedir/MergeThreads.php", 'MergeThreads'),
		'mergethreads2' => array("$sourcedir/MergeThreads.php", 'MergeThreads2'),
		'mergethreads3' => array("$sourcedir/MergeThreads.php", 'MergeThreads3'),
		'ml' => array("$sourcedir/Admin.php", 'ml'),
		'mlall' => array("$sourcedir/Memberlist.php", 'MLAll'),
		'mlmemgrp' => array("$sourcedir/Memberlist.php", 'MLMemgrp'),
		'mlletter' => array("$sourcedir/Memberlist.php", 'MLByLetter'),
		'mltop' => array("$sourcedir/Memberlist.php", 'MLTop'),
		'modify' => array("$sourcedir/ModifyMessage.php", 'ModifyMessage'),
		'modify2' => array("$sourcedir/ModifyMessage.php", 'ModifyMessage2'),
		'modifyboard' => array("$sourcedir/ManageBoards.php", 'ModifyBoard'),
		'modifycat' => array("$sourcedir/ManageCats.php", 'ModifyCat'),
		'modifycatorder' => array("$sourcedir/ManageCats.php", 'ReorderCats'),
		'modifykarma' => array("$sourcedir/Karma.php", 'ModifyKarma'),
		'modifyModSettings' => array("$sourcedir/ModSettings.php", 'ModifyModSettings'),
		'modifyModSettings2' => array("$sourcedir/ModSettings.php", 'ModifyModSettings2'),
		'modmemgr' => array("$sourcedir/Admin.php", 'EditMemberGroups'),
		'modmemgr2' => array("$sourcedir/Admin.php", 'EditMemberGroups2'),
		'modsettings' => array("$sourcedir/Admin.php", 'ModifySettings'),
		'modsettings2' => array("$sourcedir/Admin.php", 'ModifySettings2'),
		'modtemp' => array("$sourcedir/Admin.php", 'ModifyTemplate'),
		'modtemp2' => array("$sourcedir/Admin.php", 'ModifyTemplate2'),
		'movethread' => array("$sourcedir/MoveThread.php", 'MoveThread'),
		'movethread2' => array("$sourcedir/MoveThread.php", 'MoveThread2'),
		'news' => array("News.php", ''),
		'notify' => array("$sourcedir/Notify.php", 'Notify'),
		'notify2' => array("$sourcedir/Notify.php", 'Notify2'),
		'notify3' => array("$sourcedir/Notify.php", 'Notify3'),
		'notify4' => array("$sourcedir/Notify.php", 'Notify4'),
		'notifyXSettings' => array("$sourcedir/Notify.php", 'NotifyXSettings'),
		'optimizetables' => array("$sourcedir/Admin.php", 'OptimizeTables'),
		'packageavatars' => array("$sourcedir/Packages.php", 'PackageAvatars'),
		'packagebrowse' => array("$sourcedir/Packages.php", 'PackageBrowse'),
		'packagecreate' => array("$sourcedir/Packages.php", 'PackageCreate'),
		'packagecreate2' => array("$sourcedir/Packages.php", 'PackageCreate2'),
		'packageget' => array("$sourcedir/PackageGet.php", 'PackageGet'),
		'packagelanguage' => array("$sourcedir/Packages.php", 'PackageLanguage'),
		'packagelist' => array("$sourcedir/Packages.php", 'PackageList'),
		'packagemod' => array("$sourcedir/Packages.php", 'PackageMod'),
		'packagemod2' => array("$sourcedir/Packages.php", 'PackageMod2'),
		'packagemod3' => array("$sourcedir/Packages.php", 'PackageMod3'),
		'packagemod4' => array("$sourcedir/Packages.php", 'PackageMod4'),
		'packagemodSQL' => array("$sourcedir/Packages.php", 'PackageModSQL'),
		'packagepremod' => array("$sourcedir/Packages.php", 'PackagePremod'),
		'packageremove' => array("$sourcedir/Packages.php", 'PackageRemove'),
		'packages' => array("$sourcedir/Packages.php", 'Packages'),
		'packageuninstall' => array("$sourcedir/Packages.php", 'PackageUninstall'),
		'pgadd' => array("$sourcedir/PackageGet.php", 'PackageServerAdd'),
		'pgremove' => array("$sourcedir/PackageGet.php", 'PackageServerRemove'),
		'pgbrowse' => array("$sourcedir/PackageGet.php", 'PackageBrowse'),
		'pgdownload' => array("$sourcedir/PackageGet.php", 'PackageDownload'),
		'pkflushlist' => array("$sourcedir/Packages.php", 'FlushInstall'),
		'pkinstalllist' => array("$sourcedir/Packages.php", 'InstalledList'),
		'post' => array("$sourcedir/Post.php", 'Post'),
		'post2' => array("$sourcedir/Post.php", 'Post2'),
		'postpoll' => array("$sourcedir/Poll.php", 'PostPoll'),
		'postpoll2' => array("$sourcedir/Poll.php", 'PostPoll2'),
		'printpage' => array("Printpage.php", ''),
		'profile' => array("$sourcedir/Profile.php", 'ModifyProfile'),
		'profile2' => array("$sourcedir/Profile.php", 'ModifyProfile2'),
		'rebuildmemlist' => array("$sourcedir/Admin.php", 'RebuildMemList'),
		'recent' => array("$sourcedir/Recent.php", 'RecentPosts'),
		'register' => array("$sourcedir/Register.php", 'Register'),
		'register2' => array("$sourcedir/Register.php", 'Register2'),
		'reminder' => array("Reminder.php", ''),
		'removeallattachments' => array("$sourcedir/ManageAttachments.php", 'RemoveAllAttachments'),
		'removeattachment' => array("$sourcedir/ManageAttachments.php", 'RemoveAttachment'),
		'removeAttachmentsByAge' => array("$sourcedir/ManageAttachments.php", 'RemoveAttachmentByAge'),
		'removeAttachmentsBySize' => array("$sourcedir/ManageAttachments.php", 'RemoveAttachmentBySize'),
		'removethread2' => array("$sourcedir/RemoveThread.php", 'RemoveThread2'),
		'removeoldthreads' => array("$sourcedir/RemoveOldThreads.php", 'RemoveOldThreads'),
		'removeoldthreads2' => array("$sourcedir/RemoveOldThreads.php", 'RemoveOldThreads2'),
		'reorderboards' => array("$sourcedir/ManageBoards.php", 'ReorderBoards'),
		'reorderboards2' => array("$sourcedir/ManageBoards.php", 'ReorderBoards2'),
		'repairboards' => array("$sourcedir/RepairBoards.php", 'RepairBoards'),
		'reporttm' => array("$sourcedir/Subs.php", 'ReportToModerator'),
		'reporttm2' => array("$sourcedir/Subs.php", 'ReportToModerator2'),
		'search' => array("$sourcedir/Search.php", 'plushSearch1'),
		'search2' => array("$sourcedir/Search.php", 'plushSearch2'),
		'sendICQpage' => array("$sourcedir/ICQPager.php", 'send_icqpage'),
		'sendtopic' => array("$sourcedir/SendTopic.php", 'SendTopic'),
		'sendtopic2' => array("$sourcedir/SendTopic.php", 'SendTopic2'),
		'setcensor' => array("$sourcedir/Admin.php", 'SetCensor'),
		'setcensor2' => array("$sourcedir/Admin.php", 'SetCensor2'),
		'setreserve' => array("$sourcedir/Admin.php", 'SetReserve'),
		'setreserve2' => array("$sourcedir/Admin.php", 'SetReserve2'),
		'showclicks' => array("$sourcedir/Admin.php", 'ShowClickLog'),
		'shownotify' => array("$sourcedir/Notify.php", 'ShowNotifications'),
		'splitthreads' => array("$sourcedir/SplitThreads.php", 'SplitThreads'),
		'splitthreads2' => array("$sourcedir/SplitThreads.php", 'SplitThreads2'),
		'splitthreads3' => array("$sourcedir/SplitThreads.php", 'SplitThreads3'),
		'splitthreads4' => array("$sourcedir/SplitThreads.php", 'SplitThreads4'),
		'stats' => array("$sourcedir/Stats.php", 'display_stats'),
		'sticky' => array("$sourcedir/Subs.php", 'Sticky'),
		'viewErrorLog' => array("$sourcedir/Errors.php", 'ViewErrorLog'),
		'viewinactive' => array("$sourcedir/Admin.php", 'ViewInactiveMembers'),
		'viewmembers' => array("$sourcedir/Admin.php", 'ViewMembers'),
		'viewprofile' => array("$sourcedir/Profile.php", 'ViewProfile'),
		'usersrecentposts' => array("$sourcedir/Profile.php", 'usersrecentposts'),
		'vote' => array("$sourcedir/Poll.php", 'Vote'),
		'yabbinfo' => array("$sourcedir/Admin.php", 'showYaBBInfo'));

	if (isset($actionArray[$action]))
	{
		$includeFile = $actionArray[$action][0];
		$executeFunction = $actionArray[$action][1];
		unset($actionArray);

		include_once $includeFile;
		if ($executeFunction != "")
			$executeFunction();
	}

	// No board? Show Board Index
	if ($currentboard == '')
	{
		include_once "$sourcedir/BoardIndex.php";
		BoardIndex();
	}

	// No action? Show Message Index
	include_once "$sourcedir/MessageIndex.php";
	MessageIndex();

	obExit();
}

function yabb_error_handler($errno, $errstr, $errfile, $errline)
{
	if (!($errno & error_reporting()))
		return;
	fatal_error("$errno: $errstr\n<br />($errfile ln $errline)");
}

function getmicrotime()
{
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}
?>