<?
/*****************************************************************************/
/* dump_database.php                                                         */
/*****************************************************************************/
/* Software Distributed by:    http://www.maincomm.de                        */
/* Support, News, Updates at:  yabbse@maincomm.de                            */
/* ========================================================================= */
/* Copyright (c) 2001-2002 The mainComm DEV Team                             */
/* The maincomm DEV Team is: Manju,Mediman                                   */
/* Software by: The maincomm Dev Team                                        */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/
$dumpdatabasephpver = 'YaBB SE 1.5.1';

include('../QueryString.php');
include("../Settings.php");

global $settings;

// MD5 Encryption
function md5_hmac($data, $key)
{
	if (strlen($key) > 64)
		$key = pack('H*', md5($key));
	$key  = str_pad($key, 64, chr(0x00));

	$k_ipad = $key ^ str_repeat(chr(0x36), 64);
	$k_opad = $key ^ str_repeat(chr(0x5c), 64);

	return md5($k_opad . pack('H*', md5($k_ipad . $data)));
}

function getTableContent($db_name, $tableName)
{
	$crlf = "\r\n";

	$result = mysql_db_query($db_name, "SELECT * FROM $tableName");
	$num_entrys = mysql_num_rows($result);

	$i = 0;

	for ($i = 0; $i < $num_entrys; $i++)
	{
		while($row = mysql_fetch_row($result)) {
			$table_list = "(";

		for($j=0; $j<mysql_num_fields($result);$j++)
			$table_list .= mysql_field_name($result,$j).", ";

			$table_list = substr($table_list,0,-2);
			$table_list .= ")";

			if(isset($GLOBALS["showcolumns"]))
				$schema_insert = "INSERT INTO $tableName $table_list VALUES (";
			else
				$schema_insert = "INSERT INTO $tableName VALUES (";

			for($j=0; $j<mysql_num_fields($result);$j++)
			{
				if(!isset($row[$j]))
					$schema_insert .= " NULL,";
				elseif($row[$j] != "")
				{
					$schema_insert .= " '" . mysql_escape_string($row[$j]) . "',";
				}
				else
					$schema_insert .= " '',";
			}
			
			$schema_insert = ereg_replace(",$", "", $schema_insert);
			$schema_insert .= ")";

			$data .= $schema_insert.";".$crlf;
		}
	}
	
	return ($data);
}

function getTableSQLData($db_name, $tableName, $crlf)
{
	$schema_create = "";
	$schema_create .= "CREATE TABLE $tableName ($crlf";

	$query = "SHOW FIELDS FROM $tableName";
	$result = mysql_db_query($db_name, $query) or mysql_die();
	
	while($row = mysql_fetch_array($result)) 
	{
		$schema_create .= "   $row[Field] $row[Type]";
		if(isset($row["Default"]) && (!empty($row["Default"]) || $row["Default"] == "0"))
			$schema_create .= " DEFAULT '$row[Default]'";
			
		if($row["Null"] != "YES")
			$schema_create .= " NOT NULL";
			
		if($row["Extra"] != "")
			$schema_create .= " $row[Extra]";
			
		$schema_create .= ",$crlf";
	}

	$schema_create = ereg_replace(",".$crlf."$", "", $schema_create);
	$result = mysql_db_query($db_name, "SHOW KEYS FROM $tableName");
	
	while($row = mysql_fetch_array($result)) 
	{
		$kname=$row['Key_name'];
		
		if(($kname != "PRIMARY") && ($row['Non_unique'] == 0)) 
		{
			$kname="UNIQUE|$kname";
		}

		if(!isset($index[$kname]))
		{
			$index[$kname] = array();
		}
		
		if($kname == "PRIMARY" && $row[7] != 0)
		{
			$length = $row[7];
			$pkey = $row['Column_name'] . "(" . $length . ")";
			$index[$kname][] = $pkey;
		}
		else
		{
			if($row[7] != 0)
			{
				$length = $row[7];
				$key = $row['Column_name'] . "(" . $length . ")";
				$index[$kname][] = $key;
			}
			else
			{
				$index[$kname][] = $row['Column_name'];
			}
		}
	}

	while(list($x, $columns) = @each($index)) 
	{
		$schema_create .= ",$crlf";
		
		if($x == "PRIMARY")
			$schema_create .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
		elseif (substr($x,0,6) == "UNIQUE")
			$schema_create .= "   UNIQUE ".substr($x,7)." (" . implode($columns, ", ") . ")";
		else
			$schema_create .= "   KEY $x (" . implode($columns, ", ") . ")";
	}

	$schema_create .= "$crlf)";
	
	return (stripslashes($schema_create));
}

function dumpDBNow($db_name, $dumpas)
{
	@set_time_limit(600);
	$crlf = "\r\n";

	//getting all tables of  database

	$tabs = mysql_list_tables($db_name);
	$num_tabs = mysql_num_rows($tabs);

	if($num_tabs != 0)
	{
		$dat = date("Ymd");
		$date = date ("Y.m.d - H:i:s");

		$filename = $db_name . "-" . $dumpas . "_" . $dat . ".sql";
		header("Content-Encoding: none");
		header("Content-type: application/octetstream");
		header("Content-disposition: filename=" . $filename);

		echo "# ==================================================$crlf";
		echo "#$crlf";
		echo "# $db_name$crlf";
		echo "# $date $name !$crlf";
		echo "#$crlf";
		echo "# ==================================================$crlf";
		echo "$crlf";


		for($i = 0; $i < $num_tabs; $i++)
		{
			$tableName = mysql_tablename($tabs, $i);

			if($dumpas != "data")
			{
				echo "$crlf";
				echo "#$crlf";
				echo "# Table structure for table '$tableName'$crlf";
				echo "#$crlf";
				echo "$crlf";

				//drop if exists
				$drop = "DROP TABLE IF EXISTS $tableName".";$crlf$crlf";
				echo "$drop";

				$data = getTableSQLData($db_name, $tableName, $crlf).";$crlf$crlf";
				echo "$data";
			}

			if($dumpas != "structure")
			{
				$get_rows = mysql_query("SELECT * FROM $tableName");
				$num_rows = mysql_num_rows($get_rows);

				if ($num_rows != 0)
				{
					echo "$crlf";
					echo "#$crlf";
					echo "# dumping data '$tableName'$crlf";
					echo "#$crlf";
					echo "$crlf";

					$content = getTableContent($db_name, $tableName);
					echo "$content";
					echo "# --------------------------------------------------------$crlf";
				}
			}
		}
	}
}


$db = mysql_connect ( $db_server, $db_user, $db_passwd );
mysql_select_db($db_name, $db);

	if (isset($HTTP_COOKIE_VARS[$cookiename]))
	{
		list($uid, $password) = @unserialize(stripslashes($HTTP_COOKIE_VARS[$cookiename]));
		$uid = (int) $uid;
		if ($uid <= 0)
			$uid = -1;
	}

$get_uid = mysql_query("SELECT ID_MEMBER, passwd FROM {$db_prefix}members WHERE ID_MEMBER='$uid' AND memberGroup='Administrator'");
$num = mysql_num_rows($get_uid);

if($db_query = mysql_fetch_array($get_uid))
{
	$uid = $db_query[0];
	$spass = md5_hmac($db_query[1], 'ys');
}

if ($num != 1 || $spass != $password)
{
	echo "Hacking attempt";
}
else
{
	dumpDBNow($db_name, $dumpas);
}

mysql_close($db);

?>